//+------------------------------------------------------------------+
//|                                        AbsoluteStrength_v1.1.mq4 |
//|                           Copyright  2006, TrendLaboratory Ltd. |
//|            http://finance.groups.yahoo.com/group/TrendLaboratory |
//|                                       E-mail: igorad2004@list.ru |
//+------------------------------------------------------------------+
#property copyright "Copyright  2006, TrendLaboratory Ltd."
#property link      "http://finance.groups.yahoo.com/group/TrendLaboratory"

#property indicator_separate_window
#property indicator_buffers    4
#property indicator_color1     LimeGreen
#property indicator_width1     2 
#property indicator_color2     Red
#property indicator_width2     2
#property indicator_color3     Green
#property indicator_width3     1
#property indicator_style3     3 
#property indicator_color4     Crimson
#property indicator_width4     1 
#property indicator_style4     3
#property indicator_levelcolor MediumOrchid

//
//
//
//
//

extern string TimeFrame   = "Current time frame";
extern int    Mode        = 1;   // 0-RSI method; 1-Stoch method; 2-ADX method
extern double Length      = 20;  
extern double Signal      = 10;  
extern double T3Hot       = 1.0;
extern bool   T3Original  = false;
extern bool   T3Adaptive  = false;
extern int    Price       = 0;   
extern double OverBought  = 0; 
extern double OverSold    = 0;  
extern bool   Interpolate = true;
  
//
//
//
//
//

double Bulls[];
double Bears[];
double SmthBulls[];
double SmthBears[];
double SigBulls[];
double SigBears[];

//
//
//
//
//

string indicatorFileName;
bool   returnBars;
bool   calculateValue;
int    timeFrame;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//

int init()
{

   IndicatorBuffers(6);
   SetIndexBuffer(0,SmthBulls); SetIndexLabel(0,"Bulls");
   SetIndexBuffer(1,SmthBears); SetIndexLabel(1,"Bears");                   
   SetIndexBuffer(2,SigBulls);  SetIndexLabel(2,"SignalBulls");
   SetIndexBuffer(3,SigBears);  SetIndexLabel(3,"SignalBears");  
   SetIndexBuffer(4,Bulls);
   SetIndexBuffer(5,Bears);
   SetLevelValue(0,0);
   
   //
   //
   //
   //
   //
       
   indicatorFileName = WindowExpertName();
   returnBars        = TimeFrame == "returnBars";     if (returnBars)     return(0);
   calculateValue    = TimeFrame == "calculateValue"; if (calculateValue) return(0);
   timeFrame         = stringToTimeFrame(TimeFrame);
          
   //
   //
   //
   //
   //
   
   IndicatorShortName(timeFrameToString(timeFrame)+  " T3 AbsoluteStrength ("+Mode+","+DoubleToStr(Length,2)+","+DoubleToStr(Signal,2)+")");
return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//

int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
           int limit=MathMin(Bars-counted_bars,Bars-1);
           if (returnBars) { SmthBulls[0] = limit+1; return(0); }

   //
   //
   //
   //
   //
   
   if (calculateValue || timeFrame == Period())
   {
   
     for (int i=limit; i>=0; i--)
     {
        double Price1 = getPrice(Price,i); 
        double Price2 = getPrice(Price,i+1);  
      
        if (Mode==0)
        {
           Bulls[i] = 0.5*(MathAbs(Price1-Price2)+(Price1-Price2));
           Bears[i] = 0.5*(MathAbs(Price1-Price2)-(Price1-Price2));
        }
        
        if (Mode==1)
        {
           double smax  = High[Highest(NULL,0,MODE_HIGH,Length,i)];
           double smin  =  Low[Lowest( NULL,0,MODE_LOW, Length,i)];
         
           Bulls[i] = Price1 - smin;
           Bears[i] = smax   - Price1;
        }
         
        if (Mode==2)
        {
           Bulls[i] = 0.5*(MathAbs(High[i]  - High[i+1]) + (High[i]  - High[i+1]));
           Bears[i] = 0.5*(MathAbs(Low[i+1] - Low[i])    + (Low[i+1] - Low[i]));
        }
      
      
      }
      
      //
      //
      //
      //
      //
      
      for (i = limit; i >= 0; i--)
      {
         SmthBulls[i] = iT3a(Bulls[i],Length,T3Hot,T3Original,T3Adaptive,i,0);    
         SmthBears[i] = iT3a(Bears[i],Length,T3Hot,T3Original,T3Adaptive,i,1);  
      }
                
      for (i = limit; i >= 0; i--)
      {
         if (OverBought > 0 && OverSold > 0 )
         {
           SigBulls[i] = OverBought/ 100 * (SmthBulls[i] + SmthBears[i]);
           SigBears[i] = OverSold  / 100 * (SmthBulls[i] + SmthBears[i]);
         }
         else
         {
           SigBulls[i] = iT3a(SmthBulls[i],Signal,T3Hot,T3Original,T3Adaptive,i,2);       
           SigBears[i] = iT3a(SmthBears[i],Signal,T3Hot,T3Original,T3Adaptive,i,3);  
         }
      }

      return(0);
      }
      
      //
      //
      //
      //
      //
      
      limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
      for (i=limit; i>=0; i--)
      {
         int y = iBarShift(NULL,timeFrame,Time[i]);               
            SmthBulls[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",Mode,Length,Signal,T3Hot,T3Original,T3Adaptive,Price,OverBought,OverSold,0,y);
            SmthBears[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",Mode,Length,Signal,T3Hot,T3Original,T3Adaptive,Price,OverBought,OverSold,1,y);
            SigBulls[i]  = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",Mode,Length,Signal,T3Hot,T3Original,T3Adaptive,Price,OverBought,OverSold,2,y);
            SigBears[i]  = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",Mode,Length,Signal,T3Hot,T3Original,T3Adaptive,Price,OverBought,OverSold,3,y);
            
            //
            //
            //
            //
            //
       
            if (timeFrame <= Period() || y==iBarShift(NULL,timeFrame,Time[i-1])) continue;
            if (!Interpolate) continue;

            //
            //
            //
            //
            //

            datetime time = iTime(NULL,timeFrame,y);
               for(int n = 1; i+n < Bars && Time[i+n] >= time; n++) continue;	
               for(int x = 1; x < n; x++)
               {
              
                  SmthBulls[i+x] = SmthBulls[i] + (SmthBulls[i+n] - SmthBulls[i]) * x/n;
                  SmthBears[i+x] = SmthBears[i] + (SmthBears[i+n] - SmthBears[i]) * x/n;
                  SigBulls[i+x]  = SigBulls[i]  + (SigBulls[i+n]  - SigBulls[i])  * x/n;
                  SigBears[i+x]  = SigBears[i]  + (SigBears[i+n]  - SigBears[i])  * x/n;
                  
               }               
   }
   return(0);
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   StringToUpper(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}

string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

double getPrice(int type, int i)
{
   switch (type)
   {
      case 7:     return((Open[i]+Close[i])/2.0);
      case 8:     return((Open[i]+High[i]+Low[i]+Close[i])/4.0);
      default :   return(iMA(NULL,0,1,0,MODE_SMA,type,i));
   }      
}

//+------------------------------------------------------------------
//|
//+------------------------------------------------------------------
//
//
//
//
//

double workT3[][28];
double workT3Coeffs[][6];
#define _period 0
#define _c1     1
#define _c2     2
#define _c3     3
#define _c4     4
#define _alpha  5
#define _atr    6

//
//
//
//
//

double iT3a(double price, double period, double hot, bool original, bool adaptive, int i, int forInstance=0)
{
   int r      = Bars-i-1;
   int buffer = forInstance*7;

   //
   //
   //
   //
   //
   
      if (ArrayRange(workT3,0) !=Bars)                  ArrayResize(workT3,Bars);
      if (ArrayRange(workT3Coeffs,0) < (forInstance+1)) ArrayResize(workT3Coeffs,forInstance+1);
      if (adaptive)
      {
         workT3[r][_atr+buffer] = iATR(NULL,0,period,i);
            double max = workT3[r][_atr+buffer];
            double min = workT3[r][_atr+buffer];
            for (int k=1; k<period && (r-k>=0); k++)
               {
                  max = MathMax(max,workT3[r-k][_atr+buffer]);
                  min = MathMin(min,workT3[r-k][_atr+buffer]);
               }
            if (min!=max)
                  double atn = 1.0-(workT3[r][_atr+buffer]-min)/(max-min);
            else         atn = 0.5;
            period = period*(atn+1.0)/2.0;
      }
   
   //
   //
   //
   //
   //
   
      if (workT3Coeffs[forInstance][_period] != period)
      {
        workT3Coeffs[forInstance][_period] = period;
           double a = hot;
               workT3Coeffs[forInstance][_c1] = -a*a*a;
               workT3Coeffs[forInstance][_c2] = 3*a*a+3*a*a*a;
               workT3Coeffs[forInstance][_c3] = -6*a*a-3*a-3*a*a*a;
               workT3Coeffs[forInstance][_c4] = 1+3*a+a*a*a+3*a*a;
               if (original)
                    workT3Coeffs[forInstance][_alpha] = 2.0/(1.0 + period);
               else workT3Coeffs[forInstance][_alpha] = 2.0/(2.0 + (period-1.0)/2.0);
      }
   
   //
   //
   //
   //
   //
   
   if (r == 0)
      {
         workT3[r][0+buffer] = price;
         workT3[r][1+buffer] = price;
         workT3[r][2+buffer] = price;
         workT3[r][3+buffer] = price;
         workT3[r][4+buffer] = price;
         workT3[r][5+buffer] = price;
      }
   else
      {
         workT3[r][0+buffer] = workT3[r-1][0+buffer]+workT3Coeffs[forInstance][_alpha]*(price              -workT3[r-1][0+buffer]);
         workT3[r][1+buffer] = workT3[r-1][1+buffer]+workT3Coeffs[forInstance][_alpha]*(workT3[r][0+buffer]-workT3[r-1][1+buffer]);
         workT3[r][2+buffer] = workT3[r-1][2+buffer]+workT3Coeffs[forInstance][_alpha]*(workT3[r][1+buffer]-workT3[r-1][2+buffer]);
         workT3[r][3+buffer] = workT3[r-1][3+buffer]+workT3Coeffs[forInstance][_alpha]*(workT3[r][2+buffer]-workT3[r-1][3+buffer]);
         workT3[r][4+buffer] = workT3[r-1][4+buffer]+workT3Coeffs[forInstance][_alpha]*(workT3[r][3+buffer]-workT3[r-1][4+buffer]);
         workT3[r][5+buffer] = workT3[r-1][5+buffer]+workT3Coeffs[forInstance][_alpha]*(workT3[r][4+buffer]-workT3[r-1][5+buffer]);
      }

   //
   //
   //
   //
   //
   
   return(workT3Coeffs[forInstance][_c1]*workT3[r][5+buffer] + 
          workT3Coeffs[forInstance][_c2]*workT3[r][4+buffer] + 
          workT3Coeffs[forInstance][_c3]*workT3[r][3+buffer] + 
          workT3Coeffs[forInstance][_c4]*workT3[r][2+buffer]);
}
     